Bug 34894 - Some compile tests require trampolines even when the target sets no_trampolines
Some compile tests require trampolines even when the target sets no_trampolines
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: testsuite
4.3.0
: P3 normal
: 4.4.0
Assigned To: Not yet assigned to anyone
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2008-01-21 02:21 UTC by Paulo Marques
Modified: 2008-05-26 20:00 UTC (History)
3 users (show)

See Also:
Host: i686-pc-linux-gnu
Target: avr-*-*
Build: i686-pc-linux-gnu
Known to work:
Known to fail:
Last reconfirmed:


Attachments
patch with possible fix (1.52 KB, patch)
2008-01-21 02:23 UTC, Paulo Marques
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Paulo Marques 2008-01-21 02:21:49 UTC
When trying to run the testsuite for the avr target I get these failures from gcc.c-torture/compile:

gcc.c-torture/compile/20010226-1.c:6: internal compiler error: trampolines not supported
gcc.c-torture/compile/20050122-2.c:7: internal compiler error: trampolines not supported
gcc.c-torture/compile/nested-1.c:9: internal compiler error: trampolines not supported
gcc.c-torture/compile/pr27889.c:3: internal compiler error: trampolines not supported

All except 20050122-2.c seem to be clear cases where trampolines are needed. 20050122-2.c might be able to work without requiring trampolines, but the address of a nested function is taken, nonetheless, so I guess we can not consider it a bug for gcc to use trampolines to compile it.
Comment 1 Paulo Marques 2008-01-21 02:23:15 UTC
Created attachment 14983 [details]
patch with possible fix


This patch fixes the test cases, by #ifndef'ing the relevant code when NO_TRAMPOLINES is defined
Comment 2 Andy Hutchinson 2008-04-09 23:59:25 UTC
Subject: Bug 34894

Author: hutchinsonandy
Date: Wed Apr  9 23:58:39 2008
New Revision: 134153

URL: http://gcc.gnu.org/viewcvs?root=gcc&view=rev&rev=134153
Log:
2008-04-09  Andy Hutchinson  <hutchinsonandy@aim.com>

	PR testsuite/34894
	PR testsuite/33782
	* lib/target-supports.dg: Add check_effective_target_trampolines.
	Disable profiling for avr-*-*.
	* gcc.c-torture/compile/pr27889.c: dg-requires trampolines.
	* gcc.c-torture/compile/nested-1.c: Ditto.
	* gcc.c-torture/compile/20050122-2.c: Ditto.
	* gcc.c-torture/compile/20010226-1.c: Ditto.
	* gcc.c-torture/compile/20010327-1.c:  Skip for avr-*-*.
	* gcc.c-torture/compile/980506-1.c: Ditto.
	* gcc.c-torture/compile/20020604-1.c: Ditto.
	* gcc.c-torture/compile/limits-stringlit.c: Ditto
	* gcc.c-torture/compile/20001226-1.c: Ditto

Modified:
    trunk/gcc/testsuite/ChangeLog
    trunk/gcc/testsuite/gcc.c-torture/compile/20001226-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/20010226-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/20010327-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/20020604-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/20050122-2.c
    trunk/gcc/testsuite/gcc.c-torture/compile/980506-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/limits-stringlit.c
    trunk/gcc/testsuite/gcc.c-torture/compile/nested-1.c
    trunk/gcc/testsuite/gcc.c-torture/compile/pr27889.c
    trunk/gcc/testsuite/lib/target-supports.exp

Comment 3 Andy Hutchinson 2008-04-12 15:39:09 UTC
Fixed 4.4.